<template>

	<div class="flex">
		<AppBreadcrumb :value="breadcrumb" />
		<div class="flex-1">&nbsp;</div>
		<ItemsSorter v-if="category" :options="sortOptions" v-model="sort" @update:modelValue="sort = $event" />
	</div>

	<!-- If the user reached an invalid category page (eg, an old URL), show the user a warning message -->
	<div v-if="!loading && ( category == null || !items.length )" class="banner banner-warning">
		<div class="banner-title">This product category is no longer available.</div>
		<div class="banner-subtitle">Click <router-link to="/" class="font-semibold link">here</router-link> to view all our products.</div>
	</div>

	<ProductList :products="pageItems" :loading="loading" class="my-4 md:my-8" />

	<AppPagination :currentPage="currentPage" :totalPages="totalPages" @pageChanged="changePage($event)" v-if="!loading" />

</template>

<script>

import categoriesService from '../services/categories-service';
import productsService from '../services/products-service';

import ProductList from '../components/ProductList.vue';
import AppPagination from '../components/AppPagination.vue';
import AppBreadcrumb from '../components/AppBreadcrumb.vue';
import ItemsSorter from '../components/ItemsSorter.vue';

import itemsPageMixin from '../mixins/itemsPageMixin';
import productsSortOptions from '../data/productsSortOptions';

let allCategories = [];

/**
 * This page shows product list currently available on the website for a given product category.
 * Most of the core functionality is shared with other product list pages, and is encapsulated inside itemsPageMixin.
 * This component mostly revolves around route handling and item fetching.
 */
export default {
	mixins: [
		itemsPageMixin
	],
	data() {
		return {
			category: null,
			sortOptions: productsSortOptions
		}
	},
	beforeRouteUpdate(to, from, next) {
		// The route has changed, so the category *might* have changed.
		if ( to.params.categorySlug !== this.category?.slug ) {
			// The requested URL is different than the previous one. Invalidate current data.
			this.loading = true;
			this.loadCategory( to.params.categorySlug ).then( () => this.loading = false );
		}
		next();
	},
	async created() {
		this.loading = true;

		// On first load, fetch the list of valid categories.
		allCategories = await categoriesService.getAllCategories();

		// Load the requested category.
		await this.loadCategory( this.$route.params.categorySlug );

		// If we were browsing a given page, restore that page.
		if ( this.$route.query.page )
			this.currentPage = Number( this.$route.query.page ) - 1;

		this.loading = false;
	},
	methods: {
		async loadCategory(categorySlug) {

			// Find the category given its slug.
			let requestedCategory = allCategories.find( category => category.slug === categorySlug );
			this.category = requestedCategory;

			// Ensure that the category is valid before attempting to fetch its items.
			if ( this.category ) {
				let items = await this.fetchItems().catch( err => {
					console.error( `An error occured while retrieving products for category ${requestedCategory.id}`, err );
					return [];
				});

				// Ignore the fetched items if the user has changed category in the mean time.
				if ( this.category.id !== requestedCategory.id ) 
					return;

				this.items = items;
			}

			// Reset the current pagination details.
			this.currentPage = 0;

		},
		async fetchItems() {
			if ( !this.category ) {
				// The given slug is not valid.
				return [];
			} else {
				return productsService.getProductsByCategory( this.category.id );
			}
		},
		changePage(newPageIndex) {

			// Update data according to the new page.
			this.currentPage = newPageIndex;

			// Store the given page in the URL, to allow restoration on refresh.
			this.$router.push( { path: this.$route.path, query: { ...this.$route.query, page: newPageIndex + 1 } } );

			// Scroll to the top of the page.
			window.scrollTo( 0, 0 );

		}
	},
	computed: {
		breadcrumb() {
			return [ { name: this.category?.name ?? 'Unknown category', url: this.$route.path } ];
		}
	},
	components: {
		ProductList,
		AppPagination,
		AppBreadcrumb,
		ItemsSorter,
	}
}
</script>
